<?php

namespace App\Http\Controllers\Resources;

use Illuminate\Http\Request;
use App\Http\Requests\SaleRequest;
use App\Http\Requests\ExportRequest;
use App\Http\Requests\ImportRequest;
use App\Http\ReportGenerator\PdfReport;
use App\Http\ReportGenerator\ExcelReport;
use App\Http\Controllers\Controller;
use App\Http\Filters\QueryBuilder;

use App\Sale;

class SaleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $queryBuilder = new QueryBuilder(new Sale, $request);

        return response()->json($queryBuilder->build()->paginate(10),200);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  App\Http\Requests\SaleRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(SaleRequest $request)
    {
      return response()->json(tap(new Sale($request->all()), function ($sale) {
          $sale->save();
      }), 201);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
      $sale=Sale::find($id);

  		if (!$sale) {
  			return response()->json(['errors'=>array(['code'=>404,'message'=>__('sales.not_find')])],404);
  		}

  		return response()->json(['status'=>'ok','data'=>$sale],200);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  App\Http\Requests\SaleRequest  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(SaleRequest $request, $id)
    {
        $sale=Sale::find($id);

    		if (!$sale) {
    			return response()->json(['errors'=>array(['code'=>404,'message'=>__('sales.not_find')])],404);
    		}

        return tap($sale)->update($request->all());
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      $sale=Sale::find($id);

      if (!$sale) {
        return response()->json(['errors'=>array(['code'=>404,'message'=>__('sales.not_find')])],404);
      }

      $sale->delete();

      return response()->json(['code'=>204,'message'=>__('strings.deleted_successfully')],204);
    }

    /**
     * Display report from a listing of the resource.
     *
     * @param  App\Http\Requests\ExportRequest $request
     * @return PDF CSV or XLS
     */
    public function export(ExportRequest $request)
    {
      $format = $request->input('format');
      $orderBy = $request->input('order_by');
      $betweenDates = ($request->input('between_dates')) ? explode(',', $request->input('between_dates')): ['',''];

      $queryBuilder = new QueryBuilder(new Sale, $request);

      $meta = [ // For displaying filters description on header
          __('strings.registered_on') => $betweenDates[0].' - '.$betweenDates[1],
          __('strings.order_by') => $orderBy,
      ];

      $columns = [ // Set Column to be displayed
          __('sales.folio') => 'folio',
          __('sales.total') => 'total',
          __('sales.status') => function($status) {
              switch ($status->status) {
                case 1:
                  return __('sales.pending');
                case 2:
                  return __('sales.approved');
                default:
                  return __('sales.cancelled');
              }
          },
      ];

      switch ($format) {
        case 'pdf':
          $report = new PdfReport();
          return $report->of(__('sales.report_title'), $meta, $queryBuilder->build()->get(), $columns)->showTotal([__('sales.total') => '$'])->download(__('sales.report_title'));
        case 'excel':
          $report = new ExcelReport();
          return $report->of(__('sales.report_title'), $meta, $queryBuilder->build()->get(), $columns)->setView('reports.list-excel-template')->download(__('sales.report_title'));
        case 'csv':
          $report = new ExcelReport();
          return $report->of(__('sales.report_title'), $meta, $queryBuilder->build()->get(), $columns)->simple()->setFormat('csv')->download(__('sales.report_title'));
        default:
          $report = new PdfReport();
          return $report->of(__('sales.report_title'), $meta, $queryBuilder->build()->get(), $columns)->showTotal([__('sales.total') => '$'])->stream();
      }
    }
}
